--models
local marioModel1
local marioModel2
local marioModel3
local marioModel4
local marioModel5

local mushroomModel1
local mushroomModel2
local mushroomModel3
local mushroomModel4

local booModel1
local booModel2
local booModel3
local booModel4
local booModel5

--frame counters
local marioFrame = 0
local mushroomFrame = 0
local booFrame = 0

local mushroomPattern = 0
local patternEnd = 0

--tracks deltaTime for updating frames every 1/30th of a second
local counter = 0

local function GetObjectRefs()
    marioModel1 = scenetree.findObject('nobody.marioModel1')
    marioModel2 = scenetree.findObject('nobody.marioModel2')
    marioModel3 = scenetree.findObject('nobody.marioModel3')
    marioModel4 = scenetree.findObject('nobody.marioModel4')
    marioModel5 = scenetree.findObject('nobody.marioModel5')

    mushroomModel1 = scenetree.findObject('nobody.mushroomModel1')
    mushroomModel2 = scenetree.findObject('nobody.mushroomModel2')
    mushroomModel3 = scenetree.findObject('nobody.mushroomModel3')
    mushroomModel4 = scenetree.findObject('nobody.mushroomModel4')

    booModel1 = scenetree.findObject('nobody.booModel1')
    booModel2 = scenetree.findObject('nobody.booModel2')
    booModel3 = scenetree.findObject('nobody.booModel3')
    booModel4 = scenetree.findObject('nobody.booModel4')
    booModel5 = scenetree.findObject('nobody.booModel5')
end

local function Show(object)
    if (type(object) ~= 'userdata') then return end
    if (object:getField('hidden',0)=='0') then return end
    object:preApply()
    object:setField('hidden','0',0)
    object:postApply()
end

local function Hide(object)
    if (type(object) ~= 'userdata') then return end
    if (object:getField('hidden',0)=='1') then return end
    object:preApply()
    object:setField('hidden','0',1)
    object:postApply()
end

local function SetModel(character, model)
    if (type(model) == 'string') then model = scenetree.findObject(model) end
    if (type(model) == 'number') then model = scenetree.findObjectById(model) end
    local isValidModel = (type(model) == 'userdata')
    if (isValidModel and model:getField('hidden',0)=='0') then return end
    if (character == 'mario') then
        Hide(marioModel1)
        Hide(marioModel2)
        Hide(marioModel3)
        Hide(marioModel4)
        Hide(marioModel5)
    end
    if (character == 'mushroom') then
        Hide(mushroomModel1)
        Hide(mushroomModel2)
        Hide(mushroomModel3)
        Hide(mushroomModel4)
    end
    if (character == 'boo') then
        Hide(booModel1)
        Hide(booModel2)
        Hide(booModel3)
        Hide(booModel4)
        Hide(booModel5)
    end
    if (isValidModel) then Show(model) end
end

local function UpdateFrames(deltaTime)
    counter = counter + (deltaTime * be:getSimulationTimeScale())
    while(counter > (1/30))
    do
        counter = counter - (1/30)

        marioFrame = (marioFrame + 1) % 102

        mushroomFrame = mushroomFrame + 1
        if (mushroomFrame >= patternEnd) then
            mushroomFrame = 0
            mushroomPattern = (mushroomPattern + 1) % 4
        end

        booFrame = (booFrame + 1) % 143
    end
end

local M = {
    onUpdate = function(deltaTime)
        local marioModel
        local mushroomModel
        local booModel
        
        if (not marioModel1) then
            GetObjectRefs()
            return
        end
    
        marioModel = nil
        if (marioFrame >= 12) then marioModel = marioModel1 end
        if (marioFrame >= 26) then marioModel = marioModel2 end
        if (marioFrame >= 38) then marioModel = marioModel3 end
        if (marioFrame >= 50) then marioModel = marioModel4 end
        if (marioFrame >= 62) then marioModel = marioModel5 end
        if (marioFrame >= 75) then marioModel = marioModel4 end
        if (marioFrame >= 88) then marioModel = marioModel5 end
        if (marioFrame >= 101) then marioModel = marioModel4 end
        SetModel('mario', marioModel)
    
        local pattern = mushroomPattern
        if (pattern == 2) then pattern = 0 end
        if (pattern == 0) then
            patternEnd = 300
            mushroomModel = mushroomModel1
            if (mushroomFrame % 60 >= 12) then mushroomModel = mushroomModel2 end
            if (mushroomFrame % 60 >= 24) then mushroomModel = mushroomModel3 end
            if (mushroomFrame % 60 >= 36) then mushroomModel = mushroomModel4 end
            if (mushroomFrame % 60 >= 48) then mushroomModel = nil end
        end
        if (pattern == 1) then
            patternEnd = 123
            mushroomModel = nil
            if (mushroomFrame >= 1) then
                mushroomModel = mushroomModel4
                if ((mushroomFrame - 1) % 10 >= 5) then mushroomModel = nil end
            end
            if (mushroomFrame >= 101) then mushroomModel = mushroomModel4 end
        end
        if (pattern == 3) then
            patternEnd = 65
            mushroomModel = nil
            if (mushroomFrame >= 23) then
                mushroomModel = mushroomModel4
                if ((mushroomFrame - 23) % 2 >= 1) then mushroomModel = nil end
            end
            if (mushroomFrame >= 63) then mushroomModel = mushroomModel4 end
        end
        SetModel('mushroom', mushroomModel)
    
        booModel = booModel1
        if (booFrame >= 8) then booModel = booModel2 end
        if (booFrame >= 13) then booModel = booModel3 end
        if (booFrame >= 18) then booModel = booModel4 end
        if (booFrame >= 23) then booModel = booModel5 end
        if (booFrame >= 61) then
            booModel = nil
            if ((booFrame - 61) % 2 >= 1) then booModel = booModel5 end
        end
        if (booFrame >= 75) then booModel = booModel5 end
        if (booFrame >= 106) then booModel = booModel4 end
        if (booFrame >= 111) then booModel = booModel3 end
        if (booFrame >= 116) then booModel = booModel2 end
        if (booFrame >= 121) then booModel = booModel1 end
        if (booFrame >= 127) then booModel = nil end
        SetModel('boo', booModel)
    
        UpdateFrames(deltaTime)
    end
}

return M